<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TipoTerceirosERP StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:TipoTerceirosERP
 * @subpackage Structs
 */
class TipoTerceirosERP extends AbstractStructBase
{
    /**
     * The Clientes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Clientes;
    /**
     * The DataUltimaActualizacao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DataUltimaActualizacao;
    /**
     * The Descricao
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Descricao;
    /**
     * The EntidadesExternas
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $EntidadesExternas;
    /**
     * The Fornecedores
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $Fornecedores;
    /**
     * The OutrosCredores
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $OutrosCredores;
    /**
     * The OutrosDevedores
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $OutrosDevedores;
    /**
     * The Protegida
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $Protegida;
    /**
     * The TipoTerceiro
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TipoTerceiro;
    /**
     * The VersaoUltAct
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $VersaoUltAct;
    /**
     * Constructor method for TipoTerceirosERP
     * @uses TipoTerceirosERP::setClientes()
     * @uses TipoTerceirosERP::setDataUltimaActualizacao()
     * @uses TipoTerceirosERP::setDescricao()
     * @uses TipoTerceirosERP::setEntidadesExternas()
     * @uses TipoTerceirosERP::setFornecedores()
     * @uses TipoTerceirosERP::setOutrosCredores()
     * @uses TipoTerceirosERP::setOutrosDevedores()
     * @uses TipoTerceirosERP::setProtegida()
     * @uses TipoTerceirosERP::setTipoTerceiro()
     * @uses TipoTerceirosERP::setVersaoUltAct()
     * @param bool $clientes
     * @param string $dataUltimaActualizacao
     * @param string $descricao
     * @param bool $entidadesExternas
     * @param bool $fornecedores
     * @param bool $outrosCredores
     * @param bool $outrosDevedores
     * @param bool $protegida
     * @param string $tipoTerceiro
     * @param string $versaoUltAct
     */
    public function __construct($clientes = null, $dataUltimaActualizacao = null, $descricao = null, $entidadesExternas = null, $fornecedores = null, $outrosCredores = null, $outrosDevedores = null, $protegida = null, $tipoTerceiro = null, $versaoUltAct = null)
    {
        $this
            ->setClientes($clientes)
            ->setDataUltimaActualizacao($dataUltimaActualizacao)
            ->setDescricao($descricao)
            ->setEntidadesExternas($entidadesExternas)
            ->setFornecedores($fornecedores)
            ->setOutrosCredores($outrosCredores)
            ->setOutrosDevedores($outrosDevedores)
            ->setProtegida($protegida)
            ->setTipoTerceiro($tipoTerceiro)
            ->setVersaoUltAct($versaoUltAct);
    }
    /**
     * Get Clientes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getClientes()
    {
        return isset($this->Clientes) ? $this->Clientes : null;
    }
    /**
     * Set Clientes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $clientes
     * @return \StructType\TipoTerceirosERP
     */
    public function setClientes($clientes = null)
    {
        // validation for constraint: boolean
        if (!is_null($clientes) && !is_bool($clientes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($clientes)), __LINE__);
        }
        if (is_null($clientes) || (is_array($clientes) && empty($clientes))) {
            unset($this->Clientes);
        } else {
            $this->Clientes = $clientes;
        }
        return $this;
    }
    /**
     * Get DataUltimaActualizacao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDataUltimaActualizacao()
    {
        return isset($this->DataUltimaActualizacao) ? $this->DataUltimaActualizacao : null;
    }
    /**
     * Set DataUltimaActualizacao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $dataUltimaActualizacao
     * @return \StructType\TipoTerceirosERP
     */
    public function setDataUltimaActualizacao($dataUltimaActualizacao = null)
    {
        // validation for constraint: string
        if (!is_null($dataUltimaActualizacao) && !is_string($dataUltimaActualizacao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dataUltimaActualizacao)), __LINE__);
        }
        if (is_null($dataUltimaActualizacao) || (is_array($dataUltimaActualizacao) && empty($dataUltimaActualizacao))) {
            unset($this->DataUltimaActualizacao);
        } else {
            $this->DataUltimaActualizacao = $dataUltimaActualizacao;
        }
        return $this;
    }
    /**
     * Get Descricao value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescricao()
    {
        return isset($this->Descricao) ? $this->Descricao : null;
    }
    /**
     * Set Descricao value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descricao
     * @return \StructType\TipoTerceirosERP
     */
    public function setDescricao($descricao = null)
    {
        // validation for constraint: string
        if (!is_null($descricao) && !is_string($descricao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descricao)), __LINE__);
        }
        if (is_null($descricao) || (is_array($descricao) && empty($descricao))) {
            unset($this->Descricao);
        } else {
            $this->Descricao = $descricao;
        }
        return $this;
    }
    /**
     * Get EntidadesExternas value
     * @return bool|null
     */
    public function getEntidadesExternas()
    {
        return $this->EntidadesExternas;
    }
    /**
     * Set EntidadesExternas value
     * @param bool $entidadesExternas
     * @return \StructType\TipoTerceirosERP
     */
    public function setEntidadesExternas($entidadesExternas = null)
    {
        // validation for constraint: boolean
        if (!is_null($entidadesExternas) && !is_bool($entidadesExternas)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($entidadesExternas)), __LINE__);
        }
        $this->EntidadesExternas = $entidadesExternas;
        return $this;
    }
    /**
     * Get Fornecedores value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getFornecedores()
    {
        return isset($this->Fornecedores) ? $this->Fornecedores : null;
    }
    /**
     * Set Fornecedores value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $fornecedores
     * @return \StructType\TipoTerceirosERP
     */
    public function setFornecedores($fornecedores = null)
    {
        // validation for constraint: boolean
        if (!is_null($fornecedores) && !is_bool($fornecedores)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($fornecedores)), __LINE__);
        }
        if (is_null($fornecedores) || (is_array($fornecedores) && empty($fornecedores))) {
            unset($this->Fornecedores);
        } else {
            $this->Fornecedores = $fornecedores;
        }
        return $this;
    }
    /**
     * Get OutrosCredores value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getOutrosCredores()
    {
        return isset($this->OutrosCredores) ? $this->OutrosCredores : null;
    }
    /**
     * Set OutrosCredores value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $outrosCredores
     * @return \StructType\TipoTerceirosERP
     */
    public function setOutrosCredores($outrosCredores = null)
    {
        // validation for constraint: boolean
        if (!is_null($outrosCredores) && !is_bool($outrosCredores)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($outrosCredores)), __LINE__);
        }
        if (is_null($outrosCredores) || (is_array($outrosCredores) && empty($outrosCredores))) {
            unset($this->OutrosCredores);
        } else {
            $this->OutrosCredores = $outrosCredores;
        }
        return $this;
    }
    /**
     * Get OutrosDevedores value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getOutrosDevedores()
    {
        return isset($this->OutrosDevedores) ? $this->OutrosDevedores : null;
    }
    /**
     * Set OutrosDevedores value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $outrosDevedores
     * @return \StructType\TipoTerceirosERP
     */
    public function setOutrosDevedores($outrosDevedores = null)
    {
        // validation for constraint: boolean
        if (!is_null($outrosDevedores) && !is_bool($outrosDevedores)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($outrosDevedores)), __LINE__);
        }
        if (is_null($outrosDevedores) || (is_array($outrosDevedores) && empty($outrosDevedores))) {
            unset($this->OutrosDevedores);
        } else {
            $this->OutrosDevedores = $outrosDevedores;
        }
        return $this;
    }
    /**
     * Get Protegida value
     * @return bool|null
     */
    public function getProtegida()
    {
        return $this->Protegida;
    }
    /**
     * Set Protegida value
     * @param bool $protegida
     * @return \StructType\TipoTerceirosERP
     */
    public function setProtegida($protegida = null)
    {
        // validation for constraint: boolean
        if (!is_null($protegida) && !is_bool($protegida)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($protegida)), __LINE__);
        }
        $this->Protegida = $protegida;
        return $this;
    }
    /**
     * Get TipoTerceiro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoTerceiro()
    {
        return isset($this->TipoTerceiro) ? $this->TipoTerceiro : null;
    }
    /**
     * Set TipoTerceiro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoTerceiro
     * @return \StructType\TipoTerceirosERP
     */
    public function setTipoTerceiro($tipoTerceiro = null)
    {
        // validation for constraint: string
        if (!is_null($tipoTerceiro) && !is_string($tipoTerceiro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipoTerceiro)), __LINE__);
        }
        if (is_null($tipoTerceiro) || (is_array($tipoTerceiro) && empty($tipoTerceiro))) {
            unset($this->TipoTerceiro);
        } else {
            $this->TipoTerceiro = $tipoTerceiro;
        }
        return $this;
    }
    /**
     * Get VersaoUltAct value
     * @return string|null
     */
    public function getVersaoUltAct()
    {
        return $this->VersaoUltAct;
    }
    /**
     * Set VersaoUltAct value
     * @param string $versaoUltAct
     * @return \StructType\TipoTerceirosERP
     */
    public function setVersaoUltAct($versaoUltAct = null)
    {
        // validation for constraint: string
        if (!is_null($versaoUltAct) && !is_string($versaoUltAct)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($versaoUltAct)), __LINE__);
        }
        $this->VersaoUltAct = $versaoUltAct;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TipoTerceirosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
